
Uses Local;





Procedure CheckGrids;

Const MaxDiff = 0.0001;

Var ION1, ION2: File;

     Procedure IsError;

     Begin
          Writeln ('ERROR - Grids did not match.');
          Beep;
          Wait;
          Halt (1);
     End;

     Function CheckInteger: Integer;
     Var I1, I2: Integer;
     Begin
          BlockRead (ION1, I1, SizeOf (Integer));
          BlockRead (ION2, I2, SizeOf (Integer));
          If (I1 <> I2) Then IsError;
          CheckInteger := I1;
     End;

     Function CheckSingle: Single;
     Var X1, X2, Sum: Single;
     Begin
          BlockRead (ION1, X1, SizeOf (Single));
          BlockRead (ION2, X2, SizeOf (Single));
          Sum := Abs (X1 + X2)/2.0;
          If (Sum > 1.0e-25)
             Then If ((Abs (X1 - X2)/Sum) > MaxDiff)
             Then
               Begin
                  Writeln ('Sum = ', Sum, '  X1 = ', X1, '   X2 = ', X2, '   Abs (X1-X2)/Sum = ', Abs (X1-X2)/Sum);
                  IsError;
               End;
          CheckSingle := X1;
     End;

     Function CheckDouble: Double;
     Var X1, X2, Sum: Double;
     Begin
          BlockRead (ION1, X1, SizeOf (Double));
          BlockRead (ION2, X2, SizeOf (Double));
          Sum := Abs (X1 + X2)/2.0;
          If (Sum > 1.0e-25)
             Then If ((Abs (X1 - X2)/Sum) > MaxDiff)
             Then
               Begin
                  Writeln ('Sum = ', Sum, '  X1 = ', X1, '   X2 = ', X2, '   Abs (X1-X2)/Sum = ', Abs (X1-X2)/Sum);
                  IsError;
               End;
          CheckDouble := X1;
     End;

     Function SkipDouble: Double;
     Var X1, X2: Double;
     Begin
          BlockRead (ION1, X1, SizeOf (Double));
          BlockRead (ION2, X2, SizeOf (Double));
          SkipDouble := X1;
     End;


     Procedure CheckGrid;

     Var IX, IY, IR, NX, NY, NR: Integer;

     Begin

         NX := CheckInteger;
         NY := CheckInteger;
         NR := CheckInteger;

         Writeln ('Checking Grid - NX = ', NX, '  NY = ', NY, '  NR = ', NR);

         Writeln ('Grid Time = ', CheckDouble:11:5);
         SkipDouble;

         For IX := 1 to NX do
             For IY := 1 to NY do
                 CheckSingle;

         For IR := 1 to NR do
            CheckSingle;

     End;  (*  void CheckGrid  *)


Var i, NG: Integer;

Begin

     Assign (ION1, 'pascal.grd');
     Assign (ION2, 'ansic.grd');

     Reset (ION1, 1);
     Reset (ION2, 1);

     NG := CheckInteger;

     writeln ('NX = ', CheckInteger);
     writeln ('NY = ', CheckInteger);
     writeln ('NR = ', CheckInteger);

     For i := 1 to NG do
        CheckGrid;

     Close (ION1);
     Close (ION2);

End;     (*   Procedure CheckGrids   *)










Begin

     CheckGrids;

     Writeln ('Grid Files Matched');

End.
